                                        Martha Greenberg
                                        6.034
                                        Problem Set #6

Problem 1
---------

Part A:

(load-option 'format)

(define (gather-stats)
  (define neg-num '0)
  (define prim-num '0)
  (define sec-num '0)
  (define comp-num '0)
  (define neg-fnd '0)
  (define prim-fnd '0)
  (define sec-fnd '0)
  (define comp-fnd '0)
  (define (stats-aux diag)
    (let ((d (car diag)))
      (cond ((equal? d 'negative) 
	     (set! neg-num (1+ neg-num))
	     (if (equal? (identify diag) 'negative)
		 (set! neg-fnd (1+ neg-fnd))))
	    ((equal? d 'primary) 
	     (set! prim-num (1+ prim-num))
	     (if (equal? (identify diag) 'primary)
		 (set! prim-fnd (1+ prim-fnd))))
	    ((equal? d 'secondary)
	     (set! sec-num (1+ sec-num))
	     (if (equal? (identify diag) 'secondary)
		 (set! sec-fnd (1+ sec-fnd))))
	    ((equal? d 'compensated) 
	     (set! comp-num (1+ comp-num))
	     (if (equal? (identify diag) 'compensated)
		 (set! comp-fnd (1+ comp-fnd)))))))
  (map (lambda (f) (stats-aux f)) *test-data*)
  (format #t "~% ~a / ~a negative, ~% ~a / ~a primary, ~% ~a / ~a secondary, ~% ~a / ~a compensated."
	  neg-fnd neg-num prim-fnd prim-num sec-fnd sec-num comp-fnd comp-num))


(gather-stats)

 437 / 443 negative,
 9 / 12 primary,
 0 / 1 secondary,
 8 / 17 compensated.
;No value

Part B:

 100%	|
98.6%	|			   X
	|
	|
	|
negs	|
	|
	|
	|
	|
	|
	|
   0%	-----------------------------------------------------------
	0%			  56.6 %    pos		 	100%


Problem 2
---------

This is not a bargain, since we already have that level of accuracy in
the code we already have (presuming that both the training and test sets
are representative of the patient population).


Problem 3
---------

Part A:

 100%	|
	|			
	|
	|
	|
comp	|
47.1%	|					X
	|
	|
	|
	|
	|
   0%	-----------------------------------------------------------
	0%		    primary		75%	 	100%



Part B:

The conforms to the principle of using and staying within abstraction
barriers.

The line that needs to be changed is:

	(define (record-attributes record) (cdr record))

and the new line is:

(define (record-attributes record) `(,(list-ref record 2) 
				     ,(list-ref record 9) 
				     ,@(list-tail record 16)))


(gather-stats)
 438 / 443 negative,
 9 / 12 primary,
 0 / 1 secondary,
 8 / 17 compensated.
;No value


Part C:


(make-normalizing-vector)
(make-tree)
(gather-stats)
 437 / 443 negative,
 9 / 12 primary,
 0 / 1 secondary,
 6 / 17 compensated.
;No value


 100%	|
	|			
	|
	|
	|
comp	|
	|
35.3%	|					X
	|
	|
	|
	|
   0%	-----------------------------------------------------------
	0%		    primary		75%	 	100%


You should not be happy with the results of the experiment, since fewer
compensated hypothyroid cases were diagnosed correctly.

Problem 4
---------

There is no hope of doing better diagnoses on secondary hypothyroid
cases, given this training set, as there are no cases of secondary
hypothyroid in the training set.


Problem 5
---------

My expectation is that the results using multiple nearest neighbors will
be better, since using multiple nearest neighbors allows one to get a
result that is closer to the correct point.


(define *neighbors* '4)
(gather-stats)
 439 / 443 negative,
 11 / 12 primary,
 0 / 1 secondary,
 5 / 17 compensated.
;No value


