(load-option 'format)

(define (gather-stats)
  (define neg-num '0)
  (define prim-num '0)
  (define sec-num '0)
  (define comp-num '0)
  (define neg-fnd '0)
  (define prim-fnd '0)
  (define sec-fnd '0)
  (define comp-fnd '0)
  (define (stats-aux diag)
    (let ((d (car diag)))
      (cond ((equal? d 'negative) 
	     (set! neg-num (1+ neg-num))
	     (if (equal? (identify diag) 'negative)
		 (set! neg-fnd (1+ neg-fnd))))
	    ((equal? d 'primary) 
	     (set! prim-num (1+ prim-num))
	     (if (equal? (identify diag) 'primary)
		 (set! prim-fnd (1+ prim-fnd))))
	    ((equal? d 'secondary)
	     (set! sec-num (1+ sec-num))
	     (if (equal? (identify diag) 'secondary)
		 (set! sec-fnd (1+ sec-fnd))))
	    ((equal? d 'compensated) 
	     (set! comp-num (1+ comp-num))
	     (if (equal? (identify diag) 'compensated)
		 (set! comp-fnd (1+ comp-fnd)))))))
  (map (lambda (f) (stats-aux f)) *test-data*)
  (format #t "~% ~a / ~a negative, ~% ~a / ~a primary, ~% ~a / ~a secondary, ~% ~a / ~a compensated."
	  neg-fnd neg-num prim-fnd prim-num sec-fnd sec-num comp-fnd comp-num))

	  




